package ui.view;

import javax.swing.JSplitPane;
import javax.swing.JScrollPane;
import javax.swing.JPanel;

import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JLabel;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;

import classes.HolonObject;
import classes.PropertyDataSet;
import interfaces.GraphListener;

import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JTree;
import java.awt.Color;
import javax.swing.border.LineBorder;

public class splitPane extends JSplitPane implements GraphListener {
	private JTextField graphNrTxtField;
	private JTextField redField;
	private JTextField greenField;
	private JTextField blueField;
	private JTree objectTree;
	private DefaultTreeModel treeModel;
	private DefaultMutableTreeNode objectsNode;
	private DefaultMutableTreeNode wholeHolon;
	private Hashtable<String, Hashtable<String, PropertyDataSet>> objectHashtable;

	JLabel showObjectlbl;
	JLabel showPropertylbl;
	public splitPane() {
		
		objectHashtable = new Hashtable<String, Hashtable<String, PropertyDataSet>>();

		JPanel panel = new JPanel();
		setLeftComponent(panel);
		
		JScrollPane treeScrollPane = new JScrollPane();
		
		JLabel lblObject = new JLabel("Object(s):");
		
		showObjectlbl = new JLabel("...");
		
		JLabel lblProperty = new JLabel("Property:");
		
		showPropertylbl = new JLabel("...");
		
		JLabel lblGraph = new JLabel("Graph:");
		
		graphNrTxtField = new JTextField();
		graphNrTxtField.setColumns(10);
		
		JLabel lblColor = new JLabel("Color:");
		
		JComboBox colorComboBox = new JComboBox();
		
		redField = new JTextField();
		redField.setColumns(10);
		
		greenField = new JTextField();
		greenField.setColumns(10);
		
		blueField = new JTextField();
		blueField.setColumns(10);
		
		JLabel lblR = new JLabel("R:");
		
		JLabel lblG = new JLabel("G:");
		
		JLabel lblB = new JLabel("B:");
		
		JButton btnAdd = new JButton("Add");
		
		JPanel colorPanel = new JPanel();
		colorPanel.setBorder(new LineBorder(new Color(0, 0, 0)));
		colorPanel.setBackground(Color.WHITE);
		GroupLayout gl_panel = new GroupLayout(panel);
		gl_panel.setHorizontalGroup(
			gl_panel.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel.createParallelGroup(Alignment.LEADING, false)
						.addComponent(treeScrollPane, GroupLayout.PREFERRED_SIZE, 165, GroupLayout.PREFERRED_SIZE)
						.addGroup(gl_panel.createSequentialGroup()
							.addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
								.addComponent(lblGraph)
								.addComponent(lblObject)
								.addComponent(lblProperty)
								.addComponent(lblColor)
								.addGroup(gl_panel.createSequentialGroup()
									.addComponent(lblR)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addGroup(gl_panel.createParallelGroup(Alignment.LEADING, false)
										.addComponent(colorPanel, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
										.addComponent(redField, GroupLayout.DEFAULT_SIZE, 37, Short.MAX_VALUE))))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_panel.createParallelGroup(Alignment.LEADING, false)
								.addComponent(showObjectlbl, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(showPropertylbl, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(colorComboBox, 0, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addGroup(gl_panel.createSequentialGroup()
									.addGroup(gl_panel.createParallelGroup(Alignment.TRAILING)
										.addComponent(btnAdd)
										.addGroup(gl_panel.createSequentialGroup()
											.addComponent(lblG)
											.addPreferredGap(ComponentPlacement.RELATED)
											.addComponent(greenField, GroupLayout.PREFERRED_SIZE, 37, GroupLayout.PREFERRED_SIZE)))
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(lblB)
									.addPreferredGap(ComponentPlacement.RELATED)
									.addComponent(blueField, GroupLayout.PREFERRED_SIZE, 37, GroupLayout.PREFERRED_SIZE))
								.addComponent(graphNrTxtField))))
					.addContainerGap())
		);
		gl_panel.setVerticalGroup(
			gl_panel.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel.createSequentialGroup()
					.addContainerGap()
					.addComponent(treeScrollPane, GroupLayout.PREFERRED_SIZE, 153, GroupLayout.PREFERRED_SIZE)
					.addGap(27)
					.addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblObject, GroupLayout.PREFERRED_SIZE, 14, GroupLayout.PREFERRED_SIZE)
						.addComponent(showObjectlbl))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblProperty)
						.addComponent(showPropertylbl))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblGraph)
						.addComponent(graphNrTxtField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblColor)
						.addComponent(colorComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(18)
					.addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblR)
						.addComponent(redField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(lblG)
						.addComponent(greenField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(lblB)
						.addComponent(blueField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addComponent(colorPanel, GroupLayout.PREFERRED_SIZE, 33, GroupLayout.PREFERRED_SIZE)
					.addPreferredGap(ComponentPlacement.RELATED, 30, Short.MAX_VALUE)
					.addComponent(btnAdd)
					.addContainerGap())
		);
		
		objectTree = new JTree();
		treeModel = (DefaultTreeModel)objectTree.getModel();
		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Statistics");
		wholeHolon = new DefaultMutableTreeNode("whole Holon");
		wholeHolon.add(new DefaultMutableTreeNode("total Production"));
		wholeHolon.add(new DefaultMutableTreeNode("total Consumption"));
		wholeHolon.add(new DefaultMutableTreeNode("Percentage of Supplied Objects"));
		wholeHolon.add(new DefaultMutableTreeNode("Percentage of not Supplied Objects"));
		wholeHolon.add(new DefaultMutableTreeNode("Percentage of partially Supplied Objects"));

		objectsNode = new DefaultMutableTreeNode("Objects");
		DefaultMutableTreeNode defaultNode = new DefaultMutableTreeNode("empty");
	
		objectsNode.add(defaultNode);
		treeModel.setRoot(root);
		root.add(wholeHolon);
		root.add(objectsNode);
		objectTree.setModel(treeModel);
		
		treeScrollPane.setViewportView(objectTree);
		
		objectTree.addTreeSelectionListener(new TreeSelectionListener(){

			@Override
			public void valueChanged(TreeSelectionEvent e) {
				showObjectlbl.setText("...");
				showPropertylbl.setText("...");
				 DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)objectTree.getLastSelectedPathComponent();
				 if(selectedNode == null){
					 return;
				 }else{
					 if(selectedNode.getLevel() == 1){
						 showObjectlbl.setText(selectedNode.toString());
					 }
					 if(selectedNode.getLevel() == 2){
						 if(((DefaultMutableTreeNode)selectedNode.getParent()).toString().equals("whole Holon")){
							 showPropertylbl.setText(selectedNode.toString());
							 showObjectlbl.setText(selectedNode.getParent().toString());
						 }else{
							 showObjectlbl.setText(selectedNode.toString());
						 }
					 }
					 if(selectedNode.getLevel() == 3){
						 String object = ((DefaultMutableTreeNode)selectedNode.getParent()).toString();
						 String property = selectedNode.toString();
						 int r = objectHashtable.get(object).get(property).getColor().getRed();
						 redField.setText(Integer.toString(r));
						 int g = objectHashtable.get(object).get(property).getColor().getGreen();
						 greenField.setText(Integer.toString(g));
						 int b = objectHashtable.get(object).get(property).getColor().getBlue();
						 blueField.setText(Integer.toString(b));
						 
						 showObjectlbl.setText(object);
						 showPropertylbl.setText(property);
						 graphNrTxtField.setText(objectHashtable.get(object).get(property).getAssignedGraph());
					 }
				 }
			}
			
		});
		panel.setLayout(gl_panel);
		
		JScrollPane graphScrollPane = new JScrollPane();
		setRightComponent(graphScrollPane);
		repaintGraph();
	}
	@Override
	public void repaintGraph() {
		treeModel.reload();
	}
	@Override
	public void addTrackedObject(ArrayList<HolonObject> hlList) {
		if(hlList.size() > 0 && hlList != null){
			objectsNode.removeAllChildren();
			for(HolonObject hO : hlList){
				Hashtable<String, PropertyDataSet> tmpHash = new Hashtable<String, PropertyDataSet>();
				String name = hO.getName() + " " + hO.getID();
				DefaultMutableTreeNode tmp = new DefaultMutableTreeNode(name);
				tmp.add(new DefaultMutableTreeNode("total Production"));
				tmp.add(new DefaultMutableTreeNode("total Consumption"));
				tmp.add(new DefaultMutableTreeNode("number of activated Elements"));
				tmpHash.put("total Production", new PropertyDataSet());
				tmpHash.put("total Consumption", new PropertyDataSet());
				tmpHash.put("number of activated Elements", new PropertyDataSet());
				objectHashtable.put(name, tmpHash);
				objectsNode.add(tmp);
			}
		}else{
			objectsNode.add(new DefaultMutableTreeNode("empty"));
		}
		
	}
}
